Package com.avaya.clientservices.collaboration

## Interface WhiteboardSurfaceListener

-     public interface WhiteboardSurfaceListener

  Represents `WhiteboardSurface` page listener which retrieves callbacks to add/update/remove/clear events on the whiteboard page.

  Client doesn't need to implement this protocol unless a custom whiteboard canvas is developed.

  See Also:
    `WhiteboardSurface`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `onEndDrawShape​(WhiteboardSurface surface, AbstractShape shape)` | Reports that on whiteboard page user has finished drawing shape.
    `void` | `onShapeAdded​(WhiteboardSurface surface, AbstractShape shape)` | Reports that on whiteboard page add shape event occurs.
    `void` | `onShapeAddFailed​(WhiteboardSurface surface, AbstractShape shape, CollaborationFailure failure)` | Reports that on whiteboard page add shape event fails.
    `void` | `onShapeAddSuccess​(WhiteboardSurface surface, AbstractShape shape)` | Reports that on whiteboard page add shape event successfully occurs.
    `void` | `onShapeDeleted​(WhiteboardSurface surface, AbstractShape shape)` | Reports that on whiteboard page delete shape event occurs.
    `void` | `onShapeDeleteFailed​(WhiteboardSurface surface, AbstractShape shape, CollaborationFailure failure)` | Reports that on whiteboard page delete shape event fails.
    `void` | `onShapeDeleteSuccess​(WhiteboardSurface surface, AbstractShape shape)` | Reports that on whiteboard page delete shape event successfully occurs.
    `void` | `onShapeMoved​(WhiteboardSurface surface, AbstractShape shape)` | Reports that on whiteboard page move shape event occurs.
    `void` | `onShapeUpdated​(WhiteboardSurface surface, AbstractShape shape)` | Reports that on whiteboard page update (drawing) shape event occurs.
    `void` | `onShapeUpdateFailed​(WhiteboardSurface surface, AbstractShape shape, CollaborationFailure failure)` | Reports that on whiteboard page update shape event fails.
    `void` | `onShapeUpdateSuccess​(WhiteboardSurface surface, AbstractShape shape)` | Reports that on whiteboard page update shape event successfully occurs.
    `void` | `onSurfaceCleared​(WhiteboardSurface surface)` | Reports that on whiteboard page clear all shapes event occurs.
    `void` | `onSurfaceClearFailed​(WhiteboardSurface surface, CollaborationFailure failure)` | Reports that on whiteboard page clear all shapes event fails.
    `void` | `onSurfaceClearSuccess​(WhiteboardSurface surface)` | Reports that on whiteboard page clear all shapes event successfully occurs.

- - ### Method Detail

    - #### onShapeAdded

          void onShapeAdded​(WhiteboardSurface surface,
                            AbstractShape shape)

      Reports that on whiteboard page add shape event occurs.
      Parameters:
        `surface` - whiteboard page on which add event occurs.
        `shape` - shape object which is added.

    - #### onShapeAddSuccess

          void onShapeAddSuccess​(WhiteboardSurface surface,
                                 AbstractShape shape)

      Reports that on whiteboard page add shape event successfully occurs.
      Parameters:
        `surface` - whiteboard page on which add event successfully occurs.
        `shape` - shape object which is added.

    - #### onShapeAddFailed

          void onShapeAddFailed​(WhiteboardSurface surface,
                                AbstractShape shape,
                                CollaborationFailure failure)

      Reports that on whiteboard page add shape event fails.
      Parameters:
        `surface` - whiteboard page on which add event fails.
        `shape` - shape object which fails to be added.
        `failure` - failure reason.

    - #### onShapeUpdated

          void onShapeUpdated​(WhiteboardSurface surface,
                              AbstractShape shape)

      Reports that on whiteboard page update (drawing) shape event occurs.
      Parameters:
        `surface` - whiteboard page on which update event occurs.
        `shape` - shape object which is updated.

    - #### onShapeUpdateSuccess

          void onShapeUpdateSuccess​(WhiteboardSurface surface,
                                    AbstractShape shape)

      Reports that on whiteboard page update shape event successfully occurs.
      Parameters:
        `surface` - whiteboard page on which update event successfully occurs.
        `shape` - shape object which is updated.

    - #### onShapeUpdateFailed

          void onShapeUpdateFailed​(WhiteboardSurface surface,
                                   AbstractShape shape,
                                   CollaborationFailure failure)

      Reports that on whiteboard page update shape event fails.
      Parameters:
        `surface` - whiteboard page on which update event fails.
        `shape` - shape object which is failed to update.
        `failure` - failure reason.

    - #### onShapeMoved

          void onShapeMoved​(WhiteboardSurface surface,
                            AbstractShape shape)

      Reports that on whiteboard page move shape event occurs.
      Parameters:
        `surface` - whiteboard page on which move event occurs.
        `shape` - shape object which is moved.

    - #### onShapeDeleted

          void onShapeDeleted​(WhiteboardSurface surface,
                              AbstractShape shape)

      Reports that on whiteboard page delete shape event occurs.
      Parameters:
        `surface` - whiteboard page on which delete event occurs.
        `shape` - shape object which is deleted.

    - #### onShapeDeleteSuccess

          void onShapeDeleteSuccess​(WhiteboardSurface surface,
                                    AbstractShape shape)

      Reports that on whiteboard page delete shape event successfully occurs.
      Parameters:
        `surface` - whiteboard page on which delete event successfully occurs.
        `shape` - shape object which is deleted.

    - #### onShapeDeleteFailed

          void onShapeDeleteFailed​(WhiteboardSurface surface,
                                   AbstractShape shape,
                                   CollaborationFailure failure)

      Reports that on whiteboard page delete shape event fails.
      Parameters:
        `surface` - whiteboard page on which delete event fails.
        `shape` - shape object which is failed to delete.
        `failure` - failure reason.

    - #### onSurfaceCleared

          void onSurfaceCleared​(WhiteboardSurface surface)

      Reports that on whiteboard page clear all shapes event occurs.
      Parameters:
        `surface` - whiteboard page on which clear all shapes event occurs.

    - #### onSurfaceClearSuccess

          void onSurfaceClearSuccess​(WhiteboardSurface surface)

      Reports that on whiteboard page clear all shapes event successfully occurs.
      Parameters:
        `surface` - whiteboard page on which clear all shapes event successfully occurs.

    - #### onSurfaceClearFailed

          void onSurfaceClearFailed​(WhiteboardSurface surface,
                                    CollaborationFailure failure)

      Reports that on whiteboard page clear all shapes event fails.
      Parameters:
        `surface` - whiteboard page on which clear all shapes event fails.
        `failure` - failure reason.

    - #### onEndDrawShape

          void onEndDrawShape​(WhiteboardSurface surface,
                              AbstractShape shape)

      Reports that on whiteboard page user has finished drawing shape.
      Parameters:
        `surface` - whiteboard page.
        `shape` - shape object which is finished.